#
# Ubuntu PractiTest Community results processor
# Copyright (C) 2015 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from ubuntu_pt_community import auth

from flask import request


api_preamble = 'v1'


def define_routes(webapp):
    webapp.add_url_rule(
        '/{}/upload'.format(api_preamble),
        view_func=upload,
        methods=['POST']
    )
    
    
def upload():
    # Steps:
    #  - Authenticate request (i.e. do we know this person and care?)
    #  - Grab uploaded data
    #  - Upload to PT
    #  ? Keep local (raw) copy?

    # First pass lets explicitly do the auth stuff, then we can do something
    # smarter and more elegant.
    # Currently will blow up if if doesn't validate.
    # auth.validate_request(request)

    print('V1 files>')
    print(request.files)

    print('file data>p')
    try:
        print(request.files['data'].stream.getvalue())
        # XXX This is where the PractiTest upload method/code goes.
    except KeyError:
        print('No files provided.')

    return 'Uploading successful.'
