#
# Ubuntu PractiTest Community results processor
# Copyright (C) 2015 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

"""SSO authentication."""

import json
import requests

# SSO_BASE_URL = 'https://login.ubuntu.com/api/v2'
# Use the following for SSO staging:
SSO_BASE_URL = 'https://login.staging.ubuntu.com/api/v2'


JSON_HEADERS = {
    'Content-Type': 'application/json',
    'Accept': 'application/json',
}


def validate_request(response):
    """Validate an sso request.

    :param request: flask request object.

    :raises: exception if not valid.

    """
    # need to catch key exception here.
    data = dict(
        http_url=response.url,
        http_method=response.method,
        authorization=response.headers['Authorization'])

    # Note this is a POST request (unathenticated endpoint)
    validate_response = requests.post(
        SSO_BASE_URL + '/requests/validate', json.dumps(data),
        headers=JSON_HEADERS)
    assert validate_response.ok, validate_response
    return validate_response.json()
